﻿Type=Service
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
    #StartAtBoot: True
#End Region

Sub Process_Globals
Dim sf As StringFunctions
End Sub

Sub Service_Create
End Sub

Sub Service_Start (StartingIntent As Intent)

	'maybe set last start "Time" to file / ketstore
	'Read on Service Start to determine last start time .. and set ScheduleNextServiceStart  accordingly.
	'rewrite new start time to file /keystore
	
	
	'schedule next service regardless
	ScheduleNextServiceStart(14,15)

	' if starting intent was Not from reboot or Main activity it must have been from scheduled restart ..
	'show notification and stop service
	If StartingIntent.Action <> "android.intent.action.BOOT_COMPLETED" AND _
		StartingIntent.Action <> "Started_From_MAIN" Then		
    	Dim n As Notification
    	n.Initialize
    	n.Icon = "icon"
		Dim notifitext As String
    	n.SetInfo("App Name", messagetxt(sf.Mid(GetDefaultLanguage,1,2)), Main)				
		n.Notify(1) 		
	End If
		
	StopService("")		

End Sub

Sub ScheduleNextServiceStart(Hours As Int, Minutes As Int)
	
	'determine current day of week ..
	Dim DayofWeek As Int = DateTime.GetDayOfWeek(DateTime.Now)
	Dim DaysToRestart As Int
	
	Select Case DayofWeek ' depending on what day it is .. we calculate period to next run day ( wednesday or friday)
		Case 1	'sunday
			DaysToRestart = 6
		Case 2	'monday
			DaysToRestart = 5
		Case 3	'tuesday
			DaysToRestart = 4
		Case 4	'wednesday
			DaysToRestart = 3
		Case 5	'thursday
			DaysToRestart = 2
		Case 6	'friday
			DaysToRestart = 1
		Case 7	'saturday	
			DaysToRestart = 7
	End Select
	
	Dim Ticks, Today, NextRunTime As Long
	Ticks = Hours * DateTime.TicksPerHour + Minutes * DateTime.TicksPerMinute 
	Today = DateTime.DateParse(DateTime.Date(DateTime.Now))

    NextRunTime = Today + (DaysToRestart * DateTime.TicksPerDay) + Ticks

	StartServiceAt("",NextRunTime,True)
	
	DateTime.DateFormat = "EEEE  dd / MMM / yyyy"
	Log("NextRunTime : " & DateTime.Date(NextRunTime)  & " At " & DateTime.Time(NextRunTime) & " Hours")
	
End Sub
Sub GetDefaultLanguage As String
Dim r As Reflector
Return r.RunStaticMethod("java.util.Locale", "getDefault", Null, Null)
End Sub

Sub messagetxt(lann1 As String)
'lann11 is the string text notification message
Dim lann11 As String
lann11="Notification in English"
Select Case lann1
Case "en"
lann11="Notification in English"
Case "it"
lann11="Notifica in Italiano"
Case "de"
lann11="Meldung in Deutsch"
Case "nl"
lann11="Kennisgeving in het Nederlands"
Case "es"
lann11="Notificación en español"
Case "fr"
lann11="Français"
Case "pl"
lann11="Polski"
Case "pt"
lann11="Português"
Case "ru"
lann11="Pусский"
Case "sv"
lann11="Svenska"
Case "zh"
lann11="中國"
End Select
Return lann11
End Sub